/**
 *
 * Copyright (C) 2014 Olivier Berthier
 *                    http://www.xunil.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 **/

#ifndef _BSPHERE_H
#define _BSPHERE_H

#include <GL/gl.h>
#include <math.h>
#include <vector>
#include <iostream>
#include "Donnees.h"

class BBox;
/* class BSphere; */
/* class BSH; */
class tree;

class BBox{
  friend tree;
  //  friend BSphere;
 public:
  BBox(){
    init();
  }
  BBox(const Coord&,const Coord&);
  ~BBox(){} 
  void add(const Coord&);
  int intersect(const BBox&);
  /* int intersect(const BSphere&); */
  int inside(const Coord&);
  void init(){
    empty = 1;
  }
  void draw() const;
 protected:
  Coord max,min;
  int empty;
};


class tree {
 private:
  int depth;
  int axisRetries;
  int axis;
  BBox bounds;
  std::vector<Coord> objects;
  tree* left;
  tree* right;
 public:
  tree(){}
 tree(int depth_, int axis_, std::vector<Coord> objects_) :
  depth(depth_), axis(axis_), objects(objects_) {
    axisRetries=0;
    left = right = NULL;
    build();
  }
  ~tree(){}
  
  void clear(){

  }
  void build();
  int toggleAxis();
  int inside(const Coord& p){
    if (bounds.inside(p)) {
      if(left == NULL && right==NULL)
	return 1;
      int leftIntersection=0;
      int rightIntersection=0;
      if (left != NULL)
	leftIntersection = left->inside(p);
      if( right != NULL)
	rightIntersection = right->inside(p);
      //      std::cout<<depth<<" "<<	leftIntersection<<" "<<	rightIntersection<<std::endl; 
      return leftIntersection || rightIntersection;
    } 
  
    return 0;
  }
  void draw() const{
    bounds.draw();
    if(left!=NULL)
      left->draw();
    if(right!=NULL)
      right->draw();
  }
};


/* class BSphere{ */
/*   friend BSH; */
/*   friend BBox; */
/*  public : */
/*   BSphere(); */
/*   BSphere(const Coord&, float); */
/*   ~BSphere(); */

/*   inline void  translate(const Coord& c){ */
/*     position += c; */
/*   } */
/*   inline void rotate(const Coord& r){ */
/*     rotation += r; */
/*   } */

/*   inline float getRayon() const{ */
/*     return rayon; */
/*   } */

/*   inline Coord getCenter(){ */
/*     return position; */
/*   } */

/*   inline void setCenter(const Coord& c){ */
/*     position = c; */
/*   } */

/*   inline const Coord& getCenter()const{ */
/*     return position; */
/*   } */
  
/*   int inside(const Coord&) const;  */

/*   int intersect(const BBox&) const; */

/*   void draw() const; */
/*  protected : */
/*   Coord position; */
/*   Coord rotation; */
/*   float rayon; */
/*   BSphere* left; */
/*   BSphere* right; */
/* }; */




#endif
